#include <18F4620.h>
#device adc=8

#fuses INTRC_IO,NOWDT,NOPROTECT,BROWNOUT,PUT,NOLVP 

#use delay(clock=32M)
//#use rs232(ICD,baud=115200,parity=N,xmit=PIN_C6,rcv=PIN_C7,bits=9,DEBUGGER)
#use rs232(baud=115200,parity=N,xmit=PIN_C6,rcv=PIN_C7,bits=9)
//#use rs232(ICD,baud=115200)

#define GLCD_WIDTH   128

#define FAST_GLCD

#rom  0xF00026={0}

#define GLCD_E       PIN_A5   // Enable
#define GLCD_DI      PIN_A2
#define GLCD_CS1     PIN_A0   // Chip Selection 1
#define GLCD_CS2     PIN_A1
#define GLCD_RW      PIN_A4   // Read/Write

#define saghop    PIN_C1
#define solhop    PIN_C2 

#define tmod1     PIN_C0
#define tmod2     PIN_C3
#define tmod3     PIN_C4
#define tmod4     PIN_C5

#define tust2     PIN_B0
#define talt2     PIN_B3
#define tust1     PIN_B7
#define talt1     PIN_E1

#define tort1     PIN_E0
#define tort2     PIN_B2

#define tsol1     PIN_B6
#define tsag1     PIN_E2
#define tsol2     PIN_B1
#define tsag2     PIN_B4

#include "HDM64GS12.c"
#include <graphics.c>
#include "maps.h"

#define RTC_SDA  PIN_A6
#define RTC_SCL  PIN_A7

#include <ds1307.c>
#include <1wire1.c>

//char  endtas[] =  " Ozkal Ozsoy";

int soly, sagy;
int solx= 3, sagx= 124;
int solhed, saghed;
float topx=64, topy=32, artimx=1, artimy=1;
int ballturn ;
int16  puansol=0, puansag=0;
int1 demomod;

float temperature;

  BYTE sec; 
  BYTE min; 
  BYTE hrs; 
  BYTE day; 
  BYTE month; 
  BYTE yr; 
  BYTE dow; 


//-------------------------{}----------------------------
void beep(int16 period){
if ( demomod == 1 ) return;
   while((period--) != 0)
   {
      output_high(solhop);
      output_high(saghop);
      delay_ms(1);
      output_low(solhop);
      output_low(saghop);
      delay_ms(1);
   }
}

//-------------------------{}----------------------------
void saat() 
{ 
  
  // Set date for -> 15 June 2005 Tuesday 
  // Set time for -> 15:20:55 
  //ds1307_set_date_time(15,6,5,2,15,20,55); 
    
    ds1307_get_date(day,month,yr,dow); 
    ds1307_get_time(hrs,min,sec); 
      
    printf("\f\%02d/\%02d/\%02d\r\n",day,month,yr); 
    printf("\%02d:\%02d:\%02d", hrs,min,sec); 
}
//-------------------------{}----------------------------
void rakambas(int x, int y, int rakam, int size){
char  rakamlar[] = "0000";
  
  sprintf(rakamlar,"%02d",rakam); 

glcd_text57(x, y, rakamlar , size, ON);
}
//-------------------------{}----------------------------

void bitmap_pong(int x, int y)
{
int i,j, sayac=0, k; 
int width = 64;
int height = 64;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(pong[sayac],k))
               glcd_pixel(x+j,y+i+k,ON); 
            else 
               glcd_pixel(x+j,y+i+k,OFF); 
      }
      sayac++;
   }
}
}
//-------------------------{}----------------------------
void bitmap_ball(int x, int y)
{
int i,j, sayac=0, k; 
int width = 5;
int height = 5;
x=x-2;
y=y-2;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(ball[sayac],k))
               glcd_pixel(x+j,y+i+k,ON); 
      }
      sayac++;
   }
}

if(artimx==1){
   switch (ballturn) {

   case 4:glcd_pixel(x+3,y+2,OFF); 
          break;

   case 3:glcd_pixel(x+2,y+1,OFF); 
          break;
           
   case 2:glcd_pixel(x+1,y+2,OFF); 
          break;           
           
   case 1:glcd_pixel(x+2,y+3,OFF); 
          break;           

   default:ballturn=1;
            break; 
   }
}
else{
   switch (ballturn) {

   case 1:glcd_pixel(x+3,y+2,OFF); 
          break;

   case 2:glcd_pixel(x+2,y+1,OFF); 
          break;
           
   case 3:glcd_pixel(x+1,y+2,OFF); 
          break;           
           
   case 4:glcd_pixel(x+2,y+3,OFF); 
          break;           

   default:ballturn=1;
            break; 
   }
}
//glcd_pixel(x+2,y+2,OFF); 
ballturn++;
if (ballturn == 5 ) ballturn=1;

} 
//-------------------------{}----------------------------
void bitmap_reprogram(int xs, int ys)
{

int i, j, k;
int16 sayac2=0 ;

int width = 128;
int height = 64;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(reprogram[sayac2],k)){
               glcd_pixel(xs+j,ys+i+k,ON); 
               }
      }
      sayac2++;
   }
}
}
//-------------------------{}----------------------------
void bitmap_picpong(int xs, int ys)
{

int i, j, k;
int16 sayac2=0 ;

int width = 128;
int height = 64;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(picpong[sayac2],k)){
               glcd_pixel(xs+j,ys+i+k,ON); 
               }
      }
      sayac2++;
   }
}
}
//-------------------------{}----------------------------
void bitmap_raket(int x, int y)
{
int i,j, sayac=0, k; 
int width = 32;
int height = 32;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(raket[sayac],k))
               glcd_pixel(x+j,y+i+k,ON); 
            //else 
               //glcd_pixel(x+j,y+i+k,OFF); 
      }
      sayac++;
   }
}
}
/*/-------------------------{}----------------------------
void bitmap_top(int x, int y)
{
int i,j, sayac=0, k; 
int width = 18;
int height = 7;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(top[sayac],k))
               glcd_pixel(x+j,y+i+k,ON); 
            else 
               glcd_pixel(x+j,y+i+k,OFF); 
      }
      sayac++;
   }
}
}
*///-------------------------{}----------------------------
void ilkekran(int16 bekleme){


bitmap_picpong(0, 0);


glcd_line(124,63,127,63,OFF);

glcd_update();
delay_ms(bekleme);
}
//-------------------------{}----------------------------   
void sahayiciz(){
int sayac;
   glcd_line(4, 62 , 123, 62, ON); // Saha alt izgileri
   glcd_line(0, 61 , 127, 61, ON); // Saha alt izgileri
   glcd_line(4, 0 , 123, 0, ON); // Saha st izgileri
   glcd_line(0, 1 , 127, 1, ON); // Saha st izgileri
   for (sayac = 0; sayac <64 ; sayac+= 5) glcd_line(64, sayac, 64, sayac+2 , ON);
}
//-------------------------{}----------------------------


//-------------------------{}----------------------------


void main()
{

int saatsay, tempsay;
int depo200;


   setup_adc_ports(NO_ANALOGS);
   setup_psp(PSP_DISABLED);
   setup_oscillator(OSC_32MHZ | OSC_PLL_ON);   
   setup_comparator(NC_NC_NC_NC);
   
   printf(" Ozkal's PIC-PONG (%s) (%s )\n\r",__FILENAME__,__DATE__); 

   glcd_init(ON);      

   ilkekran(1000);
   
/*   
   depo200=read_eeprom(38);
   if(depo200 <= 200) goto normalcalis;
   glcd_fillScreen(OFF);
   bitmap_reprogram(0, 0);
   glcd_update();
   while(TRUE);

normalcalis:

   depo200++;
   write_eeprom( 38 , depo200 );

*/   
   
   
   ds1307_init(); 

   port_b_pullups( TRUE );

   
   saatsay=1;
   tempsay=30;   

demomod=1;   

enbas0:

   soly=31;
   sagy=31;

enbas:

   topx=64; 
   topy=31;
   
   solx=7;
   sagx=120;
   
   ballturn=1;

   //ds1307_set_date_time(26, 5, 12, 1, 12, 34, 0);
   
   glcd_fillScreen(OFF);
   glcd_update();
   
   bitmap_ball(topx,topy);
   
   sahayiciz();
   glcd_update();
   delay_ms(100);
   

      
//\/\/\/\/\/\/\/\/\/ANA DNG\/\/\/\/\/\/\/\/\/
   while(TRUE){
   
   restart_wdt();
   
   glcd_fillScreen(OFF);
   
   sahayiciz();
   
   if (input(tmod1)==0 && hrs < 24) { hrs++; ds1307_set_date_time(26, 5, 12, 1, hrs, min, sec); delay_ms(50);}
   if (input(tmod2)==0 && hrs > 0 ) { hrs--; ds1307_set_date_time(26, 5, 12, 1, hrs, min, sec); delay_ms(50); }
   if (input(tmod3)==0 && min < 60) { min++; ds1307_set_date_time(26, 5, 12, 1, hrs, min, sec); delay_ms(50); }
   if (input(tmod4)==0 && min > 0 ) { min--; ds1307_set_date_time(26, 5, 12, 1, hrs, min, sec); delay_ms(50); }
 
   if ( (input(tort1)==0 || input(tort2)==0 )&& demomod == 1) { beep(40); demomod=0; goto enbas0; }
  
if(demomod == 1){
   if ( topx>63 ) {
      saghed = topy;
      solhed = 64 - topy;
   }
  
   if ( topx<63 ) {
      solhed = topy;
      saghed = 64 - topy;
   }
   if (solhed > soly && soly<=50 ) soly++;
   if (solhed < soly && soly>=12 ) soly--;
   if (saghed > sagy && sagy<=50 ) sagy++;
   if (saghed < sagy && sagy>=12 ) sagy--;

   if(!saatsay--) {
      saatsay=100;   
//      beep(1);
      saat();
      
   }
   rakambas(40, 46 , (int16) hrs ,2);
   rakambas(68, 46 , (int16) min ,2);

   if(!tempsay--) {
      tempsay=255;   
      temperature = ds1820_read();   
      printf("\fTemp %f", temperature); 
   }

   rakambas(40, 5 , (int) temperature ,2);   
   rakambas(68, 5 , (temperature - (int) temperature)*100, 2 );   

}
else{
   if ( puansol == 100 ) puansol = 0;
   if ( puansag == 100 ) puansag = 0;   
   
   rakambas( 30 , 3 , puansol, 1);
   rakambas( 90 , 3 , puansag, 1);
   //printf("\fSkor %lu : %lu", puansol, puansag); 
}

   if (soly > 52) soly = 52;
   if (sagy > 52) sagy = 52;  
   //if (soly < 11) soly = 11;
   //if (sagy < 11) sagy = 11;        
   
   bitmap_ball(topx,topy);
   
   topx += artimx;
   topy += artimy;

// Tulara bak   
   if (input(tsol1)==0 && solx > 2 ) solx-=2;
   if (input(tsag1)==0 && solx < 40) solx++;
   if (input(tust1)==0 && soly>10 ) soly-=1;
   if (input(talt1)==0 && soly<52 ) soly+=1;
   
   if (input(tsol2)==0 && sagx >  85) sagx--;
   if (input(tsag2)==0 && sagx < 125) sagx+=2;
   if (input(tust2)==0 && sagy>10 ) sagy-=1;
   if (input(talt2)==0 && sagy<52 ) sagy+=1;


// Topun karlanma durumuna bak
   if( topx == sagx-1 ){
      if( topy > sagy-9 && topy< sagy+9) { 
         artimx = -artimx;
         beep(5);
         if( topy >= sagy+6 && ( artimy==-1 || artimy==0 ) ) { artimy=1;}
         if( topy <= sagy-6 && ( artimy== 1 || artimy==0 ) ) { artimy=-1;}
      }
   }
   if(topx >= sagx-4 && input(tsol2)==0){
       if( topy > sagy-9 && topy< sagy+9 ) { artimy=0; artimx=-1;}
   }

   if( topx == solx+1 ){
      if( topy > soly-9 && topy< soly+9 )  { 
         artimx = -artimx; 
         beep(5);
         if( topy >= soly+6 && (artimy==-1 || artimy==0 ) ) { artimy=1;}
         if( topy <= soly-6 && (artimy== 1 || artimy==0 ) )  { artimy=-1;}         
      }
   }
   if(topx <= solx+4 && input(tsag1)==0){
      if( topy > soly-9 && topy< soly+9 && input(tsag1)==0){ artimy=0; artimx=1;}   
   }
   
//printf("\fTopx: %u", topx);    
   
// Gol olma durumuna bak
   if( topx >= 127 ) { 
         puansol++;
         //artimx=-1;
         beep(30);
         goto enbas;
      }
   if( topx <= 1 || topx > 240) { 
         puansag++;
         //artimx=1;
         beep(30);
         goto enbas;
      }
     
// Top alt ve ste gelmise sektir      
   if( topy == 58 ) { artimy = -artimy; beep(1);}
   if( topy == 4 )  { artimy = -artimy; beep(1); }
   
// Raketleri iz   
   glcd_line( solx   , soly-5, solx, soly+5, ON);
   glcd_line( solx-1 , soly-8, solx-1 , soly+8, ON);
   glcd_line( solx-2 , soly-8, solx-2 , soly+8, ON);
   glcd_line( sagx  , sagy-5, sagx, sagy+5, ON);
   glcd_line( sagx+1, sagy-8, sagx+1 , sagy+8, ON);
   glcd_line( sagx+2, sagy-8, sagx+2 , sagy+8, ON);
   glcd_pixel(solx,soly, OFF);
   glcd_pixel(sagx,sagy, OFF);   

   
   glcd_update();
   delay_ms(50);
   }
}

